lev

## Class Ln

- java.lang.Object
- - lev.Ln

-     public class Ln
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Ln()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.String` | `arrayPrintInts(int[] input)` Prints the integer representation of each index in the array.
    `static int` | `arrayToInt(byte[] input)` Converts byte array to a single int, assuming little endian.
    `static int` | `arrayToInt(int[] input)` Converts int array to a single int, assuming little endian.
    `static long` | `arrayToLong(byte[] input)` Converts byte array to a single long, assuming little endian.
    `static long` | `arrayToLong(int[] input)` Converts int array to a single long, assuming little endian.
    `static java.lang.String` | `arrayToString(byte[] input)` Converts a byte array to its string equivalent.
    `static java.lang.String` | `arrayToString(int[] input)` Converts an int array to its string equivalent.
    `static int` | `bToUInt(byte in)` Converts a byte to an unsigned integer.
    `static java.lang.String` | `center(int spaces, char c, java.lang.String... input)` Centers the input inside desired width.
    `static java.lang.String` | `changeFileTypeTo(java.lang.String input, java.lang.String type)` Replaces the suffix with the desired suffix.
    `static java.lang.String` | `cleanLine(java.lang.String line, java.lang.String comment)` Removes comments, and trims whitespace
    `static boolean` | `contains(java.util.ArrayList<java.lang.String> list, java.lang.String s)` True if list has a string that contains s.
    `static boolean` | `containsEqualsIgnoreCase(java.util.ArrayList<java.lang.String> list, java.lang.String s)` True if list has a string equaling s, ignoring case.
    `static boolean` | `containsIgnoreCase(java.util.ArrayList<java.lang.String> list, java.lang.String s)`
    `static java.lang.String` | `convertBoolTo1(java.lang.Boolean input)` Converts boolean to "1" or "0"
    `static java.lang.String` | `convertBoolTo1(java.lang.String input)` Converts "true" to "1" and "false" to "0"
    `static java.lang.String` | `convertStreamToStr(java.io.InputStream is)` Exports contents of a stream to a string.
    `static void` | `copyFile(java.io.File sourceFile, java.io.File destFile)`
    `static void` | `copyFileToDir(java.io.File sourceFile, java.io.File destDir)`
    `static java.lang.Object` | `deepCopy(java.lang.Object orig)` Returns a copy of the object, or null if the object cannot be serialized.
    `static boolean` | `deleteDirectory(java.io.File directory)` Removes the directory and everything inside of it.
    `static boolean` | `equals(java.util.ArrayList lhs, java.util.ArrayList rhs, boolean ordered)` Tests whether two array lists have equal contents.
    `static void` | `expandAll(javax.swing.JTree tree, boolean expand)` Expands or minimizes all nodes in a GUI tree.
    `static void` | `expandToDepth(javax.swing.JTree tree, int depth)`
    `static java.io.File[]` | `fileDialog()` Opens a file dialog for user to pick files.
    `static int` | `gcd(int... nums)`
    `static int` | `gcd(int a, int b)` Returns the greatest common denominator.
    `static java.util.ArrayList<java.io.File>` | `generateFileList(java.io.File src, boolean addDirs)` Recursively returns all files inside of a directory and its subdirectories.
    `static java.util.ArrayList<java.io.File>` | `generateFileList(java.io.File src, int minDepth, int maxDepth, boolean addDirs)` Recursively returns all files inside of a directory and its subdirectories. Has min/max depths to exclude undesired levels.
    `static java.lang.String` | `get(java.lang.String[] arr, java.lang.String target)`
    `static java.util.ArrayList<java.lang.String>` | `getClasses(java.io.File jarPath)` A list of all the class files in a jar.
    `static java.lang.String` | `getExpansionState(javax.swing.JTree tree, int row)` Returns a string representation of the tree's expansion state.
    `static java.io.File` | `getFilepathCaseInsensitive(java.io.File test)` Returns an uppercase version of the test path if it exists.
    `static java.lang.String` | `getFileType(java.io.File f)` Returns the file extension string.
    `static java.io.File` | `getMyDocuments()`
    `static java.lang.String` | `getNAmount(int n, java.lang.String s)` Gets a string containing N number of String s.
    `static boolean` | `hasAnyKeywords(java.lang.String target, java.util.ArrayList<java.lang.String> keywords)` Checks string to see if it contains any of the keywords in the arraylist.
    `static int` | `indexOfContains(java.util.ArrayList<java.lang.String> list, java.lang.String s)` Returns the first index that has a string containing s.
    `static int` | `indexOfIgnoreCase(java.util.ArrayList<java.lang.String> list, java.lang.String s)` A contains() check that's case insensitive.
    `static java.lang.String` | `insertInStr(java.lang.String input, java.lang.String insert, int location)` Inserts a string inside the input string at the given index.
    `static boolean` | `isDescendant(javax.swing.tree.TreePath parent, javax.swing.tree.TreePath child)`
    `static boolean` | `isFileCaseInsensitive(java.io.File test)` Returns true if input is a file (case insensitive check)
    `static boolean` | `isFileType(java.io.File f, java.lang.String fileType)` True if file extension is equal to input, case insensitive.
    `static int` | `lcm(int a, int b)` Returns least common multiple
    `static int` | `lcmm(int... nums)` Returns least common multiple
    `static java.util.ArrayList<java.lang.Class>` | `loadClasses(java.io.File jarPath, boolean skipBad)` loads all classes in a jar.
    `static java.util.ArrayList<java.lang.String>` | `loadFileToStrings(java.io.File f, boolean toUpper)` Opens a file and loads in each line.
    `static java.util.ArrayList<java.lang.String>` | `loadFileToStrings(java.lang.String path, boolean toUpper)` Opens a file and loads in each line.
    `static void` | `makeDirs(java.io.File file)` Makes the directories associated with a file.
    `static void` | `makeDirs(java.lang.String file)` Makes the directories associated with a file.
    `static java.io.File` | `manualFindFile(java.lang.String fileMessageToAskUserFor, java.io.File backupFileLocation)` Asks the user to locate a file, and saves the location for next time.
    `static boolean` | `moveFile(java.io.File src, java.io.File dest, boolean eraseOldDirs)` Moves a file from one directory to another.
    `static java.lang.String` | `nanoTimeString(long nanoseconds)` Print nanoseconds to a m:s format.
    `static byte[]` | `parseHexString(java.lang.String hex)` Parses a hex string. Viable formats: 1) "0123" 2) "01 23" 3) "0x01 0x23"
    `static byte[]` | `parseHexString(java.lang.String hex, int min)` Parses a hex string. Viable formats: 1) "0123" 2) "01 23" 3) "0x01 0x23"
    `static byte[]` | `parseHexString(java.lang.String hex, int min, boolean reverse)` Parses a hex string. Viable formats: 1) "0123" 2) "01 23" 3) "0x01 0x23"
    `static java.lang.String` | `prettyPrintHex(int input)` Prints input in the form of: "([integer representation]->[hex representation])"
    `static java.lang.String` | `prettyPrintHex(long input)` Prints input in the form of: "([integer representation]->[hex representation])"
    `static java.lang.String` | `printDouble(double in, int length)` Prints a double in digit form, no scientific notation.
    `static java.lang.String` | `printHex(byte[] input, java.lang.Boolean space, java.lang.Boolean reverse)` Prints the hex string of the input
    `static java.lang.String` | `printHex(int input)` Prints the hex string of the input (assuming its one byte)
    `static java.lang.String` | `printHex(int[] input, java.lang.Boolean space, java.lang.Boolean reverse)` Prints the hex string of the input
    `static java.lang.String` | `printHex(int input, java.lang.Boolean space, java.lang.Boolean reverse, int minLength)` Prints the hex string of the input
    `static java.lang.String` | `printHex(java.lang.Integer[] input, java.lang.Boolean space, java.lang.Boolean reverse)` Prints the hex string of the input
    `static java.lang.String` | `printHex(long input)` Prints the hex string of the input (assuming its one byte)
    `static java.lang.String` | `removeFromStr(java.lang.String input, java.lang.String remove)` Removes all instances of the remove string from the input string.
    `static boolean` | `removeIgnoreCase(java.util.ArrayList<java.lang.String> list, java.lang.String s)`
    `static void` | `restoreExpanstionState(javax.swing.JTree tree, int row, java.lang.String expansionState)` Restores a tree's expansion state to a previously saved string representation.
    `static byte[]` | `reverse(byte[] input)` Reverses bytes in a byte array
    `static char[]` | `reverse(char[] input)` Reverses characters in a char array
    `static int[]` | `reverse(int[] input)` Reverses integers in an int array
    `static java.lang.String` | `reverse(java.lang.String input)` Reverse characters in the string
    `static java.io.File` | `setupFile(java.io.File f, java.lang.Boolean delete)` Make directories to file path if they don't exist. Deletes old file if delete is on.
    `static java.io.File` | `setupFile(java.lang.String s, java.lang.Boolean delete)` Make directories to file path if they don't exist. Deletes old file if delete is on.
    `static java.lang.String` | `spaceLeft(java.lang.Boolean enforce, int spaces, char c, java.lang.String... input)` Takes the input and adds the desired amount of spaces to get the end result of being "spaces" wide.
    `static java.lang.String` | `spaceRight(int spaces, char c, java.lang.String... input)` Takes the input and adds the desired amount of spaces to get the end result of being "spaces" wide.
    `static java.lang.String` | `standardizeFilePath(java.lang.String filePath)` Replaces "\\" with "/"
    `static java.lang.Boolean` | `toBool(java.lang.String input)`
    `static byte[]` | `toByteArray(int input)`
    `static byte[]` | `toByteArray(int[] input)`
    `static byte[]` | `toByteArray(int input, int size)`
    `static byte[]` | `toByteArray(int input, int minLength, int maxLength)`
    `static byte[]` | `toByteArray(long input, int minLength, int maxLength)`
    `static byte[]` | `toByteArray(java.lang.String input)` Converts string to a byte array with no null terminator.
    `static int[]` | `toIntArray(byte[] in)` Converts to int array
    `static int[]` | `toIntArray(int input)`
    `static int[]` | `toIntArray(int input, int minLength)`
    `static int[]` | `toIntArray(int input, int minLength, int maxLength)`
    `static int[]` | `toIntArray(long input)`
    `static int[]` | `toIntArray(long input, int minLength, int maxLength)`
    `static int[]` | `toIntArray(java.lang.String input)`
    `static java.lang.String` | `toJsonPretty(com.google.gson.JsonElement object, java.lang.String... exclude)` Custom JSON parser that exports it as a JSON file string.
    `static long` | `toKB(long numBytes)` Converts byte number to kilobyte number
    `static long` | `toMB(long numBytes)` Converts byte number to megabyte number
    `static java.util.ArrayList<java.lang.String>` | `toUpper(java.util.ArrayList<java.lang.String> in)` Makes every item in the ArrayList uppercase
    `static java.lang.String[]` | `toUpper(java.lang.String[] in)`
    `static boolean` | `validateCompare(java.io.File testFile, java.io.File keyFile, int numErrorsToPrint)` A simple comparison function that compares two files byte by byte, and reports the positions of any differences (eg.
    `static boolean` | `validateCompare(java.lang.String testFile, java.lang.String keyFile, int numErrorsToPrint)` A simple comparison function that compares two files byte by byte, and reports the positions of any differences (eg.
    `static void` | `writeStringsToFile(java.lang.String path, java.util.ArrayList<java.lang.String> strs)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Ln

          public Ln()

  - ### Method Detail

    - #### getMyDocuments

          public static java.io.File getMyDocuments()

      Returns:
        My documents folder for the system.

    - #### deepCopy

          public static java.lang.Object deepCopy(java.lang.Object orig)

      Returns a copy of the object, or null if the object cannot be serialized.
      Parameters:
        `orig` - Object to copy
      Returns:
        A deep copy of the object, completely separate from the original.

    - #### spaceLeft

          public static java.lang.String spaceLeft(java.lang.Boolean enforce,
                                   int spaces,
                                   char c,
                                   java.lang.String... input)

      Takes the input and adds the desired amount of spaces to get the end result of being "spaces" wide.
      Parameters:
        `enforce` - Whether to shrink the input to enforce the spaces size, or let it bleed over to print all of the input
        `spaces` - Width desired including spaces + input.
        `c` - Character to print to achieve desired width.
        `input` - Input to print.
      Returns:
        Final spaced string.

    - #### spaceRight

          public static java.lang.String spaceRight(int spaces,
                                    char c,
                                    java.lang.String... input)

      Takes the input and adds the desired amount of spaces to get the end result of being "spaces" wide. Input is aligned left, so that the spaces are on the right side.
      Parameters:
        `spaces` - Width desired including spaces + input.
        `c` - Character to print to achieve desired width.
        `input` - Input to print.
      Returns:
        Final spaced string.

    - #### center

          public static java.lang.String center(int spaces,
                                char c,
                                java.lang.String... input)

      Centers the input inside desired width.
      Parameters:
        `spaces` - Width desired.
        `c` - Character to fill to the width
        `input` - Input to center.
      Returns:
        Final string

    - #### reverse

          public static java.lang.String reverse(java.lang.String input)

      Reverse characters in the string
      Parameters:
        `input` -
      Returns:

    - #### reverse

          public static char[] reverse(char[] input)

      Reverses characters in a char array
      Parameters:
        `input` -
      Returns:

    - #### reverse

          public static int[] reverse(int[] input)

      Reverses integers in an int array
      Parameters:
        `input` -
      Returns:

    - #### reverse

          public static byte[] reverse(byte[] input)

      Reverses bytes in a byte array
      Parameters:
        `input` -
      Returns:

    - #### cleanLine

          public static java.lang.String cleanLine(java.lang.String line,
                                   java.lang.String comment)

      Removes comments, and trims whitespace
      Parameters:
        `line` -
        `comment` -
      Returns:

    - #### deleteDirectory

          public static boolean deleteDirectory(java.io.File directory)

      Removes the directory and everything inside of it.
      Parameters:
        `directory` -
      Returns:

    - #### makeDirs

          public static void makeDirs(java.io.File file)

      Makes the directories associated with a file.
      Parameters:
        `file` -

    - #### equals

          public static boolean equals(java.util.ArrayList lhs,
                       java.util.ArrayList rhs,
                       boolean ordered)

      Tests whether two array lists have equal contents.
      Parameters:
        `lhs` -
        `rhs` -
        `ordered` - Whether the contents have to be in order to count as "equal"
      Returns:

    - #### makeDirs

          public static void makeDirs(java.lang.String file)

      Makes the directories associated with a file.
      Parameters:
        `file` -

    - #### moveFile

          public static boolean moveFile(java.io.File src,
                         java.io.File dest,
                         boolean eraseOldDirs)

      Moves a file from one directory to another. (eraseOldDirs is not implemented yet)
      Parameters:
        `src` - Source file
        `dest` - Destination file
        `eraseOldDirs` - Whether to erase old empty directories.
      Returns:
        The destination file

    - #### generateFileList

          public static java.util.ArrayList<java.io.File> generateFileList(java.io.File src,
                                                           int minDepth,
                                                           int maxDepth,
                                                           boolean addDirs)

      Recursively returns all files inside of a directory and its subdirectories.
      Has min/max depths to exclude undesired levels.
      Parameters:
        `src` - Folder to recursively search
        `minDepth` - Min depth to start adding file to the list
        `maxDepth` - Max depth to add files to the list
        `addDirs` - Include directories as files in the list, followed by their contents.
      Returns:
        List of all files inside the folder and subfolders within the depth parameters.

    - #### generateFileList

          public static java.util.ArrayList<java.io.File> generateFileList(java.io.File src,
                                                           boolean addDirs)

      Recursively returns all files inside of a directory and its subdirectories.
      Parameters:
        `src` - Folder to recursively search
        `addDirs` - Include directories as files in the list, followed by their contents.
      Returns:
        List of all files inside the folder and subfolders within the depth parameters.

    - #### arrayToString

          public static java.lang.String arrayToString(int[] input)

      Converts an int array to its string equivalent.
      Parameters:
        `input` -
      Returns:

    - #### arrayToString

          public static java.lang.String arrayToString(byte[] input)

      Converts a byte array to its string equivalent.
      Parameters:
        `input` -
      Returns:

    - #### isFileCaseInsensitive

          public static boolean isFileCaseInsensitive(java.io.File test)

      Returns true if input is a file (case insensitive check)
      Parameters:
        `test` - File to check if exists
      Returns:
        true if input is a file (case insensitive check).

    - #### getFilepathCaseInsensitive

          public static java.io.File getFilepathCaseInsensitive(java.io.File test)

      Returns an uppercase version of the test path if it exists.
      Parameters:
        `test` -
      Returns:
        Uppercase version of the test file.

    - #### arrayToInt

          public static int arrayToInt(int[] input)

      Converts int array to a single int, assuming little endian.
      Parameters:
        `input` -
      Returns:

    - #### arrayToLong

          public static long arrayToLong(int[] input)

      Converts int array to a single long, assuming little endian.
      Parameters:
        `input` -
      Returns:

    - #### arrayToInt

          public static int arrayToInt(byte[] input)

      Converts byte array to a single int, assuming little endian.
      Parameters:
        `input` -
      Returns:

    - #### arrayToLong

          public static long arrayToLong(byte[] input)

      Converts byte array to a single long, assuming little endian.
      Parameters:
        `input` -
      Returns:

    - #### arrayPrintInts

          public static java.lang.String arrayPrintInts(int[] input)

      Prints the integer representation of each index in the array.
      Parameters:
        `input` -
      Returns:

    - #### printHex

          public static java.lang.String printHex(long input)

      Prints the hex string of the input (assuming its one byte)
      Parameters:
        `input` -
      Returns:

    - #### printHex

          public static java.lang.String printHex(int input)

      Prints the hex string of the input (assuming its one byte)
      Parameters:
        `input` -
      Returns:

    - #### printHex

          public static java.lang.String printHex(int input,
                                  java.lang.Boolean space,
                                  java.lang.Boolean reverse,
                                  int minLength)

      Prints the hex string of the input
      Parameters:
        `input` - integer to print
        `space` - Adds spaces in between bytes
        `reverse` - Reverses byte printout
        `minLength` - Will add filler zeros to achieve min length
      Returns:
        Final string.

    - #### printHex

          public static java.lang.String printHex(byte[] input,
                                  java.lang.Boolean space,
                                  java.lang.Boolean reverse)

      Prints the hex string of the input
      Parameters:
        `input` - array to print
        `space` - Adds spaces in between bytes
        `reverse` - Reverses byte printout
      Returns:
        Final string.

    - #### printHex

          public static java.lang.String printHex(java.lang.Integer[] input,
                                  java.lang.Boolean space,
                                  java.lang.Boolean reverse)

      Prints the hex string of the input
      Parameters:
        `input` - array to print
        `space` - Adds spaces in between bytes
        `reverse` - Reverses byte printout
      Returns:
        Final string.

    - #### printHex

          public static java.lang.String printHex(int[] input,
                                  java.lang.Boolean space,
                                  java.lang.Boolean reverse)

      Prints the hex string of the input
      Parameters:
        `input` - array to print
        `space` - Adds spaces in between bytes
        `reverse` - Reverses byte printout
      Returns:
        Final string.

    - #### prettyPrintHex

          public static java.lang.String prettyPrintHex(int input)

      Prints input in the form of: "([integer representation]->[hex representation])"
      Parameters:
        `input` - Number to print
      Returns:
        Final string

    - #### prettyPrintHex

          public static java.lang.String prettyPrintHex(long input)

      Prints input in the form of: "([integer representation]->[hex representation])"
      Parameters:
        `input` - Number to print
      Returns:
        Final string

    - #### printDouble

          public static java.lang.String printDouble(double in,
                                     int length)

      Prints a double in digit form, no scientific notation.
      Parameters:
        `in` - Double to print.
        `length` - number of characters to print.
      Returns:
        Final double print string.

    - #### getFileType

          public static java.lang.String getFileType(java.io.File f)

      Returns the file extension string. Eg "Hello.jpg" returns "jpg"
      Parameters:
        `f` -
      Returns:

    - #### isFileType

          public static boolean isFileType(java.io.File f,
                           java.lang.String fileType)

      True if file extension is equal to input, case insensitive.
      Parameters:
        `f` -
        `fileType` -
      Returns:

    - #### removeFromStr

          public static java.lang.String removeFromStr(java.lang.String input,
                                       java.lang.String remove)

      Removes all instances of the remove string from the input string.
      Parameters:
        `input` - Source string
        `remove` - String to remove
      Returns:

    - #### insertInStr

          public static java.lang.String insertInStr(java.lang.String input,
                                     java.lang.String insert,
                                     int location)

      Inserts a string inside the input string at the given index.
      Parameters:
        `input` - Source string
        `insert` - String to insert
        `location` - index to insert at.
      Returns:

    - #### convertBoolTo1

          public static java.lang.String convertBoolTo1(java.lang.String input)

      Converts "true" to "1" and "false" to "0"
      Parameters:
        `input` -
      Returns:

    - #### convertBoolTo1

          public static java.lang.String convertBoolTo1(java.lang.Boolean input)

      Converts boolean to "1" or "0"
      Parameters:
        `input` -
      Returns:

    - #### toBool

          public static java.lang.Boolean toBool(java.lang.String input)

      Parameters:
        `input` -
      Returns:
        True if string equals "1" or "true"

    - #### setupFile

          public static java.io.File setupFile(java.io.File f,
                               java.lang.Boolean delete)

      Make directories to file path if they don't exist.
      Deletes old file if delete is on.
      Parameters:
        `f` -
        `delete` -
      Returns:

    - #### setupFile

          public static java.io.File setupFile(java.lang.String s,
                               java.lang.Boolean delete)

      Make directories to file path if they don't exist.
      Deletes old file if delete is on.
      Parameters:
        `s` -
        `delete` -
      Returns:

    - #### expandAll

          public static void expandAll(javax.swing.JTree tree,
                       boolean expand)

      Expands or minimizes all nodes in a GUI tree.
      Parameters:
        `tree` -
        `expand` -

    - #### expandToDepth

          public static void expandToDepth(javax.swing.JTree tree,
                           int depth)

      Parameters:
        `tree` -
        `depth` -

    - #### parseHexString

          public static byte[] parseHexString(java.lang.String hex,
                              int min,
                              boolean reverse)

      Parses a hex string.
      Viable formats:
      1) "0123"
      2) "01 23"
      3) "0x01 0x23"
      Parameters:
        `hex` - Hex string to parse.
        `min` - Minimum length, will be filled with zeros to fill.
        `reverse` - Reverse the bytes
      Returns:
        Parsed hex string in a byte array.

    - #### parseHexString

          public static byte[] parseHexString(java.lang.String hex)

      Parses a hex string.
      Viable formats:
      1) "0123"
      2) "01 23"
      3) "0x01 0x23"
      Parameters:
        `hex` - Hex string to parse.
      Returns:
        Parsed hex string in a byte array.

    - #### parseHexString

          public static byte[] parseHexString(java.lang.String hex,
                              int min)

      Parses a hex string.
      Viable formats:
      1) "0123"
      2) "01 23"
      3) "0x01 0x23"
      Parameters:
        `hex` - Hex string to parse.
        `min` - Minimum length, will be filled with zeros to fill.
      Returns:
        Parsed hex string in a byte array.

    - #### bToUInt

          public static int bToUInt(byte in)

      Converts a byte to an unsigned integer.
      Parameters:
        `in` -
      Returns:

    - #### toIntArray

          public static int[] toIntArray(byte[] in)

      Converts to int array
      Parameters:
        `in` -
      Returns:

    - #### toIntArray

          public static int[] toIntArray(java.lang.String input)

      Parameters:
        `input` -
      Returns:

    - #### toIntArray

          public static int[] toIntArray(int input)

      Parameters:
        `input` -
      Returns:

    - #### toIntArray

          public static int[] toIntArray(int input,
                         int minLength,
                         int maxLength)

      Parameters:
        `input` -
        `minLength` -
        `maxLength` -
      Returns:

    - #### toIntArray

          public static int[] toIntArray(int input,
                         int minLength)

      Parameters:
        `input` -
        `minLength` -
      Returns:

    - #### toIntArray

          public static int[] toIntArray(long input)

      Parameters:
        `input` -
      Returns:

    - #### toIntArray

          public static int[] toIntArray(long input,
                         int minLength,
                         int maxLength)

      Parameters:
        `input` -
        `minLength` -
        `maxLength` -
      Returns:

    - #### toByteArray

          public static byte[] toByteArray(int[] input)

      Parameters:
        `input` -
      Returns:

    - #### toByteArray

          public static byte[] toByteArray(int input)

      Parameters:
        `input` -
      Returns:

    - #### toByteArray

          public static byte[] toByteArray(int input,
                           int size)

      Parameters:
        `input` -
        `size` -
      Returns:

    - #### toByteArray

          public static byte[] toByteArray(int input,
                           int minLength,
                           int maxLength)

      Parameters:
        `input` -
        `minLength` -
        `maxLength` -
      Returns:

    - #### toByteArray

          public static byte[] toByteArray(long input,
                           int minLength,
                           int maxLength)

      Parameters:
        `input` -
        `minLength` -
        `maxLength` -
      Returns:

    - #### toByteArray

          public static byte[] toByteArray(java.lang.String input)

      Converts string to a byte array with no null terminator.
      Parameters:
        `input` -
      Returns:

    - #### nanoTimeString

          public static java.lang.String nanoTimeString(long nanoseconds)

      Print nanoseconds to a m:s format.
      Parameters:
        `nanoseconds` -
      Returns:

    - #### changeFileTypeTo

          public static java.lang.String changeFileTypeTo(java.lang.String input,
                                          java.lang.String type)

      Replaces the suffix with the desired suffix.
      Parameters:
        `input` -
        `type` -
      Returns:

    - #### gcd

          public static int gcd(int a,
                int b)

      Returns the greatest common denominator.
      Parameters:
        `a` -
        `b` -
      Returns:

    - #### gcd

          public static int gcd(int... nums)

    - #### lcm

          public static int lcm(int a,
                int b)

      Returns least common multiple
      Parameters:
        `a` -
        `b` -
      Returns:

    - #### lcmm

          public static int lcmm(int... nums)

      Returns least common multiple
      Parameters:
        `nums` -
      Returns:

    - #### toMB

          public static long toMB(long numBytes)

      Converts byte number to megabyte number
      Parameters:
        `numBytes` -
      Returns:

    - #### toKB

          public static long toKB(long numBytes)

      Converts byte number to kilobyte number
      Parameters:
        `numBytes` -
      Returns:

    - #### manualFindFile

          public static java.io.File manualFindFile(java.lang.String fileMessageToAskUserFor,
                                    java.io.File backupFileLocation)
                                             throws java.io.FileNotFoundException,
                                                    java.io.IOException

      Asks the user to locate a file, and saves the location for next time. On second runthrough, the user will not be asked, and the backup file will be used instead.
      Parameters:
        `fileMessageToAskUserFor` -
        `backupFileLocation` -
      Returns:
      Throws:
        `java.io.FileNotFoundException`
        `java.io.IOException`

    - #### fileDialog

          public static java.io.File[] fileDialog()

      Opens a file dialog for user to pick files.
      Returns:
        Files user picked.

    - #### copyFile

          public static void copyFile(java.io.File sourceFile,
                      java.io.File destFile)
                               throws java.io.IOException

      Parameters:
        `sourceFile` -
        `destFile` -
      Throws:
        `java.io.IOException`

    - #### copyFileToDir

          public static void copyFileToDir(java.io.File sourceFile,
                           java.io.File destDir)
                                    throws java.io.IOException

      Parameters:
        `sourceFile` -
        `destDir` -
      Throws:
        `java.io.IOException`

    - #### validateCompare

          public static boolean validateCompare(java.io.File testFile,
                                java.io.File keyFile,
                                int numErrorsToPrint)
                                         throws java.io.FileNotFoundException,
                                                java.io.IOException

      A simple comparison function that compares two files byte by byte, and reports the positions of any differences (eg. file1[i] != file2[i]).
      Parameters:
        `testFile` - File to test to keyFile.
        `keyFile` - Validation file to be used as a desired example.
        `numErrorsToPrint` - Number of differences to print.
      Returns:
        True if files matched with NO differences.
      Throws:
        `java.io.FileNotFoundException`
        `java.io.IOException`

    - #### validateCompare

          public static boolean validateCompare(java.lang.String testFile,
                                java.lang.String keyFile,
                                int numErrorsToPrint)
                                         throws java.io.FileNotFoundException,
                                                java.io.IOException

      A simple comparison function that compares two files byte by byte, and reports the positions of any differences (eg. file1[i] != file2[i]).
      Parameters:
        `testFile` - File to test to keyFile.
        `keyFile` - Validation file to be used as a desired example.
        `numErrorsToPrint` - Number of differences to print.
      Returns:
        True if files matched with NO differences.
      Throws:
        `java.io.FileNotFoundException`
        `java.io.IOException`

    - #### isDescendant

          public static boolean isDescendant(javax.swing.tree.TreePath parent,
                             javax.swing.tree.TreePath child)

      Parameters:
        `parent` -
        `child` -
      Returns:
        True if child is a descendant of parent

    - #### getExpansionState

          public static java.lang.String getExpansionState(javax.swing.JTree tree,
                                           int row)

      Returns a string representation of the tree's expansion state. To be used to revert back to it later.
      Parameters:
        `tree` -
        `row` -
      Returns:

    - #### restoreExpanstionState

          public static void restoreExpanstionState(javax.swing.JTree tree,
                                    int row,
                                    java.lang.String expansionState)

      Restores a tree's expansion state to a previously saved string representation.
      Parameters:
        `tree` -
        `row` -
        `expansionState` -

    - #### getClasses

          public static java.util.ArrayList<java.lang.String> getClasses(java.io.File jarPath)
                                                                  throws java.io.FileNotFoundException,
                                                                         java.io.IOException

      A list of all the class files in a jar.
      Parameters:
        `jarPath` -
      Returns:
      Throws:
        `java.io.FileNotFoundException`
        `java.io.IOException`

    - #### loadClasses

          public static java.util.ArrayList<java.lang.Class> loadClasses(java.io.File jarPath,
                                                         boolean skipBad)
                                                                  throws java.net.MalformedURLException,
                                                                         java.io.FileNotFoundException,
                                                                         java.io.IOException,
                                                                         java.lang.ClassNotFoundException

      loads all classes in a jar. Optionally can skip any that throw exceptions.
      Parameters:
        `jarPath` -
        `skipBad` -
      Returns:
      Throws:
        `java.net.MalformedURLException`
        `java.io.FileNotFoundException`
        `java.io.IOException`
        `java.lang.ClassNotFoundException`

    - #### convertStreamToStr

          public static java.lang.String convertStreamToStr(java.io.InputStream is)
                                                     throws java.io.IOException

      Exports contents of a stream to a string.
      Parameters:
        `is` -
      Returns:
      Throws:
        `java.io.IOException`

    - #### toJsonPretty

          public static java.lang.String toJsonPretty(com.google.gson.JsonElement object,
                                      java.lang.String... exclude)

      Custom JSON parser that exports it as a JSON file string.
      Parameters:
        `object` -
        `exclude` -
      Returns:

    - #### loadFileToStrings

          public static java.util.ArrayList<java.lang.String> loadFileToStrings(java.io.File f,
                                                                boolean toUpper)
                                                                         throws java.io.IOException

      Opens a file and loads in each line.
      Parameters:
        `f` -
        `toUpper` -
      Returns:
        An ArrayList of all the text lines in the file.
      Throws:
        `java.io.IOException`

    - #### loadFileToStrings

          public static java.util.ArrayList<java.lang.String> loadFileToStrings(java.lang.String path,
                                                                boolean toUpper)
                                                                         throws java.io.IOException

      Opens a file and loads in each line.
      Parameters:
        `path` -
        `toUpper` -
      Returns:
        An ArrayList of all the text lines in the file.
      Throws:
        `java.io.IOException`

    - #### writeStringsToFile

          public static void writeStringsToFile(java.lang.String path,
                                java.util.ArrayList<java.lang.String> strs)
                                         throws java.io.IOException

      Parameters:
        `path` -
        `strs` -
      Throws:
        `java.io.IOException`

    - #### toUpper

          public static java.util.ArrayList<java.lang.String> toUpper(java.util.ArrayList<java.lang.String> in)

      Makes every item in the ArrayList uppercase
      Parameters:
        `in` -
      Returns:

    - #### toUpper

          public static java.lang.String[] toUpper(java.lang.String[] in)

      Parameters:
        `in` -
      Returns:

    - #### get

          public static java.lang.String get(java.lang.String[] arr,
                             java.lang.String target)

      Parameters:
        `arr` -
        `target` -
      Returns:

    - #### hasAnyKeywords

          public static boolean hasAnyKeywords(java.lang.String target,
                               java.util.ArrayList<java.lang.String> keywords)

      Checks string to see if it contains any of the keywords in the arraylist.
      Parameters:
        `target` -
        `keywords` -
      Returns:

    - #### standardizeFilePath

          public static java.lang.String standardizeFilePath(java.lang.String filePath)

      Replaces "\\" with "/"
      Parameters:
        `filePath` -
      Returns:

    - #### indexOfContains

          public static int indexOfContains(java.util.ArrayList<java.lang.String> list,
                            java.lang.String s)

      Returns the first index that has a string containing s.
      Parameters:
        `list` -
        `s` -
      Returns:

    - #### contains

          public static boolean contains(java.util.ArrayList<java.lang.String> list,
                         java.lang.String s)

      True if list has a string that contains s.
      Parameters:
        `list` -
        `s` -
      Returns:

    - #### containsIgnoreCase

          public static boolean containsIgnoreCase(java.util.ArrayList<java.lang.String> list,
                                   java.lang.String s)

    - #### containsEqualsIgnoreCase

          public static boolean containsEqualsIgnoreCase(java.util.ArrayList<java.lang.String> list,
                                         java.lang.String s)

      True if list has a string equaling s, ignoring case.
      Parameters:
        `list` -
        `s` -
      Returns:

    - #### indexOfIgnoreCase

          public static int indexOfIgnoreCase(java.util.ArrayList<java.lang.String> list,
                              java.lang.String s)

      A contains() check that's case insensitive.
      Parameters:
        `list` -
        `s` -
      Returns:

    - #### removeIgnoreCase

          public static boolean removeIgnoreCase(java.util.ArrayList<java.lang.String> list,
                                 java.lang.String s)

      Parameters:
        `list` -
        `s` -
      Returns:

    - #### getNAmount

          public static java.lang.String getNAmount(int n,
                                    java.lang.String s)

      Gets a string containing N number of String s.
      Parameters:
        `n` -
        `s` -
      Returns: